
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>scikit-learn学习之K-means聚类算法与 Mini Batch K-Means算法 / 憋错料</title>

    <meta name="description" content="scikit-learn学习之K-means聚类算法与 Mini Batch K-Means算法 ====================================================================== 本系列博客主要参考 Scikit-Learn 官方网站上的每一个算法进行,并进行部分翻译,如有错误,请大家指正 转载请注明出处 ====================================================================== K-means算法分析与Python代码实现请参考之前的两篇博客: &lt;机器学习实战 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">scikit-learn学习之K-means聚类算法与 Mini Batch K-Means算法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>======================================================================</p>
<p>本系列博客主要参考 Scikit-Learn 官方网站上的每一个算法进行，并进行部分翻译，如有错误，请大家指正</p>
<p>转载请注明出处</p>
<p>======================================================================</p>
<p>K-means算法分析与<a href="http://lib.csdn.net/base/11" rel="external nofollow noreferrer">Python</a>代码实现请参考之前的两篇博客：</p>
<p><a href="http://blog.csdn.net/gamer_gyt/article/details/48948239" rel="external nofollow noreferrer">《机器学习实战》kMeans算法（K均&#20540;聚类算法）</a></p>
<p><a href="http://blog.csdn.net/gamer_gyt/article/details/48949227" rel="external nofollow noreferrer">《机器学习实战》二分-kMeans算法（二分K均&#20540;聚类）</a></p>
<p>接下来我主要演示怎么使用Scikit-Learn完成K-means算法的调用</p>
<p>注明：本例分析是固定输入K&#20540;和输入k个初始中心点，这样做具有很大的局限性，容易陷入局部最优，可以利用其他算法（如canopy算法）进行粗聚类估计，产生n个簇，作为k-means的K&#20540;，这里不做详细说明</p>
<h1>一：K-means聚类算法</h1>
<h2>1：K-means算法简介</h2>
<p>聚类算法，数据挖掘十大算法之一，算法需要接受参数k和k个初始聚类中心，即将数据集进行聚类的数目和k个簇的初始聚类“中心”，结果是同一类簇中的对象相&#20284;度极高，不同类簇中的数据相&#20284;度极低</p>
<h2>2：K-means算法思想和描述</h2>
<p>思想：&nbsp;以空间中k个中心点进行聚类，对最靠近他们的对象归类，通过迭代的方法，逐次更新各聚类中心</p>
<p>描述：</p>
<p>(1)适当选择C个类的初始中心</p>
<p>(2)在第K此迭代中，对任意一个样本，求其到C各中心的距离，将该样本归到距离最短的中心所在的类</p>
<p>(3)利用均&#20540;等方法更新该类的中心&#20540;</p>
<p>(4)对于所有的C个聚类中心，如果利用（2）（3）的迭代法更新后，&#20540;保持不变，则迭代结束，否则继续迭代</p>
<h2>3：集合实例的简单介绍</h2>
<p>例如现在有四种药物A,B,C,D，他们分别有两个属性。如下图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDA3MjM2Njc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>将他们表示在坐标轴上为：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDA4MTQ1Mjc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><strong>第一次迭代</strong>，随机选取两个点作为初始中心点，eg c1,c2作为初始中心点，D0中分别为四个点到两个样本点的距离，X,Y为横纵坐标</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDEwMzM4MjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>A点离第一个点最近，所以group-1行A点置1，剩下的三个点离第二个中心点最近，所以group-2行置1</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDEzMTM1MTM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>此时应该更新样本点，c1不变，c2更新为（(2&#043;4&#043;5)/3,(1&#043;3&#043;4)/3）=（11/3，8/3）,更新后的数据中心点如下图红点所示</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDE2MzYxODc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><strong>第二次迭代</strong>，以（11/3，8/3）作为样本中心点，分别计算四个点到样本中心点的距离，如下图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDE5MTYyOTc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>A,B点距离第一个中心点最近，C,D点距离第二个中心点最近，所以group-1行，A,B置1，group-2行C,D置1</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDIwNTkwMzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>此时重新更新样本中心点，c1=（(1&#043;2)/2，(1&#043;1)/2）=（3/2，1），c2=（(4&#043;5)/2，(3&#043;4)/2）=（9/2，7/2）,更新后的数据中心点如下图红点所示</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDIzMzUwMDI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><strong>第三次迭代</strong>，计算同上，略过，此时数据的样本中心点不再发生变化，所以可以停止迭代，最终聚类情况如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMDI5MjYxNjA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<h2>4：下边看一个使用sklearn.Kmeans的实例（<a href="http://scikit-learn.org/dev/auto_examples/cluster/plot_kmeans_assumptions.html#example-cluster-plot-kmeans-assumptions-py" rel="external nofollow noreferrer">实例来源</a>）</h2>
<p>实例说明：利用sklearn.datasets.make_blobs产生1500条两维的数据集进行不同情况下的聚类示例，代码如下</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;#coding:utf-8
&#039;&#039;&#039;
Created on 2016/4/25

@author: Gamer Think
&#039;&#039;&#039;
import numpy as np      #科学计算包
import matplotlib.pyplot as plt      #python画图包

from sklearn.cluster import KMeans       #导入K-means算法包
from sklearn.datasets import make_blobs

plt.figure(figsize=(12, 12))

&#039;&#039;&#039;
make_blobs函数是为聚类产生数据集
产生一个数据集和相应的标签
n_samples:表示数据样本点个数,默认值100
n_features:表示数据的维度，默认值是2
centers:产生数据的中心点，默认值3
cluster_std：数据集的标准差，浮点数或者浮点数序列，默认值1.0
center_box：中心确定之后的数据边界，默认值(-10.0, 10.0)
shuffle ：洗乱，默认值是True
random_state:官网解释是随机生成器的种子
更多参数即使请参考：http://scikit-learn.org/dev/modules/generated/sklearn.datasets.make_blobs.html#sklearn.datasets.make_blobs
&#039;&#039;&#039;
n_samples = 1500
random_state = 170
X, y = make_blobs(n_samples=n_samples, random_state=random_state)

# Incorrect number of clusters
y_pred = KMeans(n_clusters=2, random_state=random_state).fit_predict(X)

plt.subplot(221)  #在2图里添加子图1
plt.scatter(X[:, 0], X[:, 1], c=y_pred) #scatter绘制散点
plt.title(&quot;Incorrect Number of Blobs&quot;)   #加标题

# Anisotropicly distributed data
transformation = [[ 0.60834549, -0.63667341], [-0.40887718, 0.85253229]]
X_aniso = np.dot(X, transformation)    #返回的是乘积的形式
y_pred = KMeans(n_clusters=3, random_state=random_state).fit_predict(X_aniso)

plt.subplot(222)#在2图里添加子图2
plt.scatter(X_aniso[:, 0], X_aniso[:, 1], c=y_pred)
plt.title(&quot;Anisotropicly Distributed Blobs&quot;)

# Different variance
X_varied, y_varied = make_blobs(n_samples=n_samples,
                                cluster_std=[1.0, 2.5, 0.5],
                                random_state=random_state)
y_pred = KMeans(n_clusters=3, random_state=random_state).fit_predict(X_varied)

plt.subplot(223)#在2图里添加子图3
plt.scatter(X_varied[:, 0], X_varied[:, 1], c=y_pred)
plt.title(&quot;Unequal Variance&quot;)

# Unevenly sized blobs
X_filtered = np.vstack((X[y == 0][:500], X[y == 1][:100], X[y == 2][:10]))
y_pred = KMeans(n_clusters=3, random_state=random_state).fit_predict(X_filtered)

plt.subplot(224)#在2图里添加子图4
plt.scatter(X_filtered[:, 0], X_filtered[:, 1], c=y_pred)
plt.title(&quot;Unevenly Sized Blobs&quot;)

plt.show() #显示图&lt;/span&gt;</pre>
<p>结果图示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjUyMzU0MzEyMDQ/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<h1>二：Mini Batch K-Means算法</h1>
<p>scikit-learn官网上对于Mini Batch K-Means算法的说明如下：</p>
<p>Mini Batch K-Means算法是K-Means算法的变种，采用小批量的数据子集减小计算时间，同时仍试图优化目标函数，这里所谓的小批量是指每次训练算法时所随机抽取的数据子集，采用这些随机产生的子集进行训练算法，大大减小了计算时间，与其他算法相比，减少了k-均&#20540;的收敛时间，小批量k-均&#20540;产生的结果，一般只略差于标准算法。</p>
<p>该算法的迭代步骤有两步：</p>
<p>1：从数据集中随机抽取一些数据形成小批量，把他们分配给最近的质心</p>
<p>2：更新质心</p>
<p>与K均&#20540;算法相比，数据的更新是在每一个小的样本集上。对于每一个小批量，通过计算平均&#20540;得到更新质心，并把小批量里的数据分配给该质心，随着迭代次数的增加，<br />
这些质心的变化是逐渐减小的，直到质心稳定或者达到指定的迭代次数，停止计算</p>
<p>Mini Batch K-Means比K-Means有更快的&nbsp;收敛速度，但同时也降低了聚类的效果，但是在实际项目中却表现得不明显</p>
<p>这是一张k-means和mini batch k-means的实际效果对比图</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjYwMDI4MjM3ODc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>下边给出显示上边这副图的代码，也是对K-Means和Mini Batch K-Means算法的一个比较：</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;#coding:utf8
&#039;&#039;&#039;
Created on 2016/4/26

@author: Gamer Think
&#039;&#039;&#039;
import time

import numpy as np
import matplotlib.pyplot as plt

from sklearn.cluster import MiniBatchKMeans, KMeans
from sklearn.metrics.pairwise import pairwise_distances_argmin
from sklearn.datasets.samples_generator import make_blobs

##############################################################################
# Generate sample data
np.random.seed(0)

batch_size = 45
centers = [[1, 1], [-1, -1], [1, -1]] #初始化三个中心
n_clusters = len(centers)       #聚类的数目为3
#产生3000组两维的数据，以上边三个点为中心，以（-10,10）为边界，数据集的标准差是0.7
X, labels_true = make_blobs(n_samples=3000, centers=centers, cluster_std=0.7)

##############################################################################
# Compute clustering with Means

k_means = KMeans(init=&#039;k-means++&#039;, n_clusters=3, n_init=10)
t0 = time.time() #当前时间
k_means.fit(X)
#使用K-Means 对 3000数据集训练算法的时间消耗
t_batch = time.time() - t0

##############################################################################
# Compute clustering with MiniBatchKMeans

mbk = MiniBatchKMeans(init=&#039;k-means++&#039;, n_clusters=3, batch_size=batch_size,
                      n_init=10, max_no_improvement=10, verbose=0)
t0 = time.time()
mbk.fit(X)
#使用MiniBatchKMeans 对 3000数据集训练算法的时间消耗
t_mini_batch = time.time() - t0

##############################################################################
# Plot result

#创建一个绘图对象, 并设置对象的宽度和高度, 如果不创建直接调用plot, Matplotlib会直接创建一个绘图对象
fig = plt.figure(figsize=(8, 3))
fig.subplots_adjust(left=0.02, right=0.98, bottom=0.05, top=0.9)
colors = [&#039;#4EACC5&#039;, &#039;#FF9C34&#039;, &#039;#4E9A06&#039;]

# We want to have the same colors for the same cluster from the
# MiniBatchKMeans and the KMeans algorithm. Let&#039;s pair the cluster centers per
# closest one.
k_means_cluster_centers = np.sort(k_means.cluster_centers_, axis=0)
mbk_means_cluster_centers = np.sort(mbk.cluster_centers_, axis=0)
k_means_labels = pairwise_distances_argmin(X, k_means_cluster_centers)
mbk_means_labels = pairwise_distances_argmin(X, mbk_means_cluster_centers)
order = pairwise_distances_argmin(k_means_cluster_centers,
                                  mbk_means_cluster_centers)

# KMeans
ax = fig.add_subplot(1, 3, 1) #add_subplot  图像分给为 一行三列，第一块
for k, col in zip(range(n_clusters), colors):
    my_members = k_means_labels == k
    cluster_center = k_means_cluster_centers[k]
    ax.plot(X[my_members, 0], X[my_members, 1], &#039;w&#039;,
            markerfacecolor=col, marker=&#039;.&#039;)
    ax.plot(cluster_center[0], cluster_center[1], &#039;o&#039;, markerfacecolor=col,
            markeredgecolor=&#039;k&#039;, markersize=6)
ax.set_title(&#039;KMeans&#039;)
ax.set_xticks(())
ax.set_yticks(())
plt.text(-3.5, 1.8,  &#039;train time: %.2fs\ninertia: %f&#039; % (
    t_batch, k_means.inertia_))

# MiniBatchKMeans
ax = fig.add_subplot(1, 3, 2)#add_subplot  图像分给为 一行三列，第二块
for k, col in zip(range(n_clusters), colors):
    my_members = mbk_means_labels == order[k]
    cluster_center = mbk_means_cluster_centers[order[k]]
    ax.plot(X[my_members, 0], X[my_members, 1], &#039;w&#039;,
            markerfacecolor=col, marker=&#039;.&#039;)
    ax.plot(cluster_center[0], cluster_center[1], &#039;o&#039;, markerfacecolor=col,
            markeredgecolor=&#039;k&#039;, markersize=6)
ax.set_title(&#039;MiniBatchKMeans&#039;)
ax.set_xticks(())
ax.set_yticks(())
plt.text(-3.5, 1.8, &#039;train time: %.2fs\ninertia: %f&#039; %
         (t_mini_batch, mbk.inertia_))

# Initialise the different array to all False
different = (mbk_means_labels == 4)
ax = fig.add_subplot(1, 3, 3)#add_subplot  图像分给为 一行三列，第三块

for k in range(n_clusters):
    different += ((k_means_labels == k) != (mbk_means_labels == order[k]))

identic = np.logical_not(different)
ax.plot(X[identic, 0], X[identic, 1], &#039;w&#039;,
        markerfacecolor=&#039;#bbbbbb&#039;, marker=&#039;.&#039;)
ax.plot(X[different, 0], X[different, 1], &#039;w&#039;,
        markerfacecolor=&#039;m&#039;, marker=&#039;.&#039;)
ax.set_title(&#039;Difference&#039;)
ax.set_xticks(())
ax.set_yticks(())

plt.show()&lt;/span&gt;</pre>
<p>更多内容请参考官方网址：http://scikit-learn.org/dev/modules/clustering.html#clustering</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-07 18:10:12 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>scikit-learn学习之K-means聚类算法与 Mini Batch K-Means算法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47EYDR0.html" rel="bookmark">转载： scikit-learn学习之K-means聚类算法与 Mini Batch K-Means算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				版权声明:&lt;—— 本文为作者呕心沥血打造,若要转载,请注明出处@http://blog.csdn.net/gamer_gyt &lt;—— 目录(?)[+] ====================================================================== 本系列博客主要参考 Scikit-Learn 官方网站上的每一个算法进行,并进行部分翻译,如有错误,请大家指正 转载请注明出处 ======================================			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pk6zg3.html" rel="bookmark">机器学习-scikit learn学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				scikit-learn官网:http://scikit-learn.org/stable/ 通常情况下,一个学习问题会包含一组学习样本数据,计算机通过对样本数据的学习,尝试对未知数据进行预测. 学习问题一般可以分为: 监督学习(supervised learning) 分类(classification) 回归(regression) 非监督学习(unsupervised learning) 聚类(clustering) 监督学习和非监督学习的区别就是,监督学习中,样本数据会包含要预测的标签(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M67YpJ0.html" rel="bookmark">&lbrack;机器学习&rsqb;&lbrack;K-Means&rsqb; 无监督学习之K均值聚类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有监督学习虽然高效.应用范围广,但最大的问题就是需要大量的有标签的数据集,但现实生活中我们遇到的大量数据都是没有明确标签的,而且对于庞大的数据集进行标注工作本身也是一项费时费力的工作模式,所以我们希望找到一种方法能自动的挖掘数据集中各变量的关系,然后&quot;总结&quot;出一些规律和特征进行分类,这样的方法我们成为无监督学习(Unsupervised learning). 在无标签的数据集中进行分类的方法成为聚类.顾名思义,聚类就是依照某种算法将相似的样本聚在一起形成一类,而不管它的标签是什么.在聚			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41zWDoM.html" rel="bookmark">Query意图分析：记一次完整的机器学习过程（scikit learn library学习笔记）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				所谓学习问题,是指观察由n个样本组成的集合,并根据这些数据来预测未知数据的性质. 学习任务(一个二分类问题): 区分一个普通的互联网检索Query是否具有某个垂直领域的意图.假设现在有一个O2O领域的垂直搜索引擎,专门为用户提供团购.优惠券的检索:同时存在一个通用的搜索引擎,比如百度,通用搜索引擎希望能够识别出一个Query是否具有O2O检索意图,如果有则调用O2O垂直搜索引擎,获取结果作为通用搜索引擎的结果补充. 我们的目的是学习出一个分类器(classifier),分类器可以理解为一个函数,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyW1jY3.html" rel="bookmark">k-均值聚类算法；二分k均值聚类算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				根据&lt;机器学习实战&gt;一书第十章学习k均值聚类算法和二分k均值聚类算法,自己把代码边敲边理解了一下,修正了一些原书中代码的细微差错.目前代码有时会出现如下4种报错信息,这有待继续探究和完善. 报错信息: Warning (from warnings module): File &quot;F:\Python2.7.6\lib\site-packages\numpy\core\_methods.py&quot;, line 55 warnings.warn(&quot;Mean of empty			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ezJlw3.html" rel="bookmark">机器学习--k均值聚类&lpar;k-means&rpar;算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.基本原理 分类是指分类器根据已标注类别的训练集,通过训练可以对未知类别的样本进行分类.分类被称为监督学习.如果训练集的样本没有标注类别,那么就需要用到聚类.聚类是把相似的样本聚成一类,这种相似性通常以距离来度量.聚类被称为无监督学习. 聚类是指根据&quot;物以类聚&quot;的原理,将本身没有类别的样本聚集成不同的组,这样的一组数据对象的集合叫做簇,并且对每一个这样的簇进行描述的过程.它的目的是使得属于同一个簇的样本之间应该彼此相似,而不同簇的样本应该足够不相似.与分类规则不同,进行聚类前并不知道			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDbVp93.html" rel="bookmark">机器学习实战笔记-利用K均值聚类算法对未标注数据分组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				聚类是一种无监督的学习,它将相似的对象归到同一个簇中.它有点像全自动分类.聚类方法几乎可以应用于所有对象,簇内的对象越相似,聚类的效果越好 簇识别给出聚类结果的含义.假定有一些数据,现在将相似数据归到一起,簇识别会告诉我们这些簇到底都是些什么.聚类与分类的最大不同在于,分类的目标事先巳知,而聚类则不一样.因为其产生的结果与分类相同,而只是类别没有预先定义,聚类有时也被称为无监督分类(unsupervised classification ). 聚类分析试图将相似对象归人同一簇,将不相似对象归到不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MX7mka4.html" rel="bookmark">ML&colon; 聚类算法R包-K中心点聚类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				K-medodis与K-means比较相似,但是K-medoids和K-means是有区别的,不一样的地方在于中心点的选取,在K-means中,我们将中心点取为当前cluster中所有数据点的平均值,在 K-medoids算法中,我们将从当前cluster 中选取这样一个点--它到其他所有(当前cluster中的)点的距离之和最小--作为中心点.K-medodis算法不容易受到那些由于误差之类的原因产生的脏数据的影响,但计算量显然要比K-means要大,一般只适合小数据量. K-medoids			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZDkKmM.html" rel="bookmark">聚类算法之K-means 、 K中心点、hierarchical methods</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				聚类算法有以下几类: 一 层次方法 层次方法创建给定数据对象集的层次分解.根据层次的分解的形成方式,层次的方法又可以分为凝聚和分裂方法. 凝聚法:自底向上.开始将每个对象形成单独的组,然后层次合并相似的组,直到所有的组合合并成一个或者满足某个终止条件. 分裂法:自顶向下.开始将所有对象置于一个簇中,每次迭代,簇分裂成更小的簇,直到每个对象都各在一个簇中或者满足某个终止条件. 二 划分方法 给定n个对象或者数据元组的数据库,划分方法构造数据的k个划分,每个划分为一个簇,k&lt;n.给定要构造的划分数组			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBmDg4.html" rel="bookmark" class="title">算法导论 第三版 9&period;3-8</a>
					<div>
						1 # -*- coding: utf-8 -*- 2 import math 3 4 def merge(l1, l2): 5 list_merge = [] 6 i = j = 0 7 while ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM6pWv3.html" rel="bookmark" class="title">Android文件存储往SD卡中写入文件路径出错问题求解。</a>
					<div>
						============问题描述============   因为学习需要  看的老罗的视频  关于数据存储往SD卡写文件的那一部分  几乎完全照办的敲的代码   结果在pad上测试的时候和预想的有区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEReX0.html" rel="bookmark" class="title">想成功运营一个网站需要具备什么条件？</a>
					<div>
						想成功运营一个网站需要具备什么条件?我们经常会听到一句话,我能做什么,我会做什么?大家注意这2者不是同一意思,社会环境允许我做什么?想成功运营一个网站就包含了上面所有条件.当然还有其他的.那么想成功运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lXEGP0.html" rel="bookmark" class="title">&lbrack;Asp&period;net&rsqb;站点地图SiteMap</a>
					<div>
						引言 在项目中发现使用站点地图的控件,之前没总结过这方面的东西,就写了一个demo测试了一下,这里记录一下,算是总结吧. Web.sitemap 1 &lt;?xml version=&quot;1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYpqB3.html" rel="bookmark" class="title">Castle&period;MVC框架介绍</a>
					<div>
						Castle.MVC目前还在Castle的Sandbox中,只是在源代码管理中有,还没有向外发布版本,这里介绍多时Web的MVC,和Castle的MonoRail相比较,这个MVC可以Asp.Net的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NpL13.html" rel="bookmark" class="title">JavaScript函数表达式</a>
					<div>
						一.序 定义函数的方式有两种:一种是函数声明,另一种就是函数表达式: 1.1 函数声明 function functionName(arg){ //函数体 } 关于函数声明,它有一个重要特征就是函数声 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjWYm0.html" rel="bookmark" class="title">新网站关键词选择的因素影响</a>
					<div>
						http://t.qq.com/nanjingxia6396 http://t.qq.com/p/t/462084121633873 http://t.qq.com/lishuixiaojiena h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBaBbA4.html" rel="bookmark" class="title">thinkphp的空控制器和空操作以及对应解决方法</a>
					<div>
						在上篇随笔中我们已经知道了tp框架的四种访问方式,那么当在地址栏输入不存在的操作方法.控制器会怎么样呢? 先看一下定义: 空操作:一个对象(控制器)调用本身不存在的方法 空控制器:在实例化控制器对象的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDNdkk3.html" rel="bookmark" class="title">Linux功能-实施一次性任务</a>
					<div>
						一.定义 at命令:定时任务,指定一个时间执行一个任务,只能执行一次. 二.选项 三.示例 1. 使用 student 用户,创建一个任务,2 分钟以后执行,在/home/student/at.txt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GyKo0.html" rel="bookmark" class="title">HDU 6156  回文 数位DP（2017CCPC）</a>
					<div>
						Palindrome Function Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 256000/256000 K (Java/Ot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zoLo3.html" rel="bookmark" class="title">SeAndroid获取以及编译过程</a>
					<div>
						对于SeAndroid的学习和研究刚刚开始,还没有了解什么是真正的SeAndroid,所以也不敢妄加评判,等学习之后再好好聊聊对于SeAndroid的看法,对于她的学习我是先从编译开始的,下面就是我的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWdXbl0.html" rel="bookmark" class="title">jdk8 eclipse luna market crashed</a>
					<div>
						THAT WORKS! Eclipse Luna starts normally when I first do the suggested: export SWT_GTK3=0 https://bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a6KRA3.html" rel="bookmark" class="title">FSDataInputStream对象 读取数据</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MznAVkM.html" rel="bookmark" class="title">mark一下。hadoop分布式系统搭建</a>
					<div>
						用于测试,我用4台虚拟机搭建成了hadoop结构 我用了两个台式机.一个xp系统,一个win7系统.每台电脑装两个虚拟机,要不然内存就满了. 1.安装虚拟机环境 Vmware,收费产品,占内存较大.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX1d680.html" rel="bookmark" class="title">DBCPTool</a>
					<div>
						dbcp读取配置文件的方式: 1. 导入3个包:commons-dbcp-...  .jar(数据源) commons-collections-.....jar(集合) commons-pool... ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPgkED4.html" rel="bookmark" class="title">浅析NRF51822之GPIOTE</a>
					<div>
						GPIOTE handling library Note This library is obsolete and should not be used in new designs. Instead ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rpyrXM.html" rel="bookmark" class="title">SqlServerProxy的一些资料</a>
					<div>
						SqlServerProxy的一些资料 下载地址:http://files.cnblogs.com/files/lyhabc/SqlServerProxy.rar 1.特性及实现原理 SqlServe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l8yjZ0.html" rel="bookmark" class="title">在Winform获取机器信息IP、MAC、机器名、CPU编号、主硬盘编号</a>
					<div>
						需引入命名空间: using System.Net; using System.Management; 1 /// &lt;summary&gt; 2 /// 获取本地IP 3 /// &lt;/su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0npvaP4.html" rel="bookmark" class="title">NBT（NetBIOS Over TCP）名称解析概述</a>
					<div>
						在微软IP网络中,客户计算机查找其他计算机并与之进行通信的主要手段是利用域名(DNS).但是,使用先前版本的Windows户机也使用NetBIOS协议,将名称解析为IP地址. 通过三种方法解析NetB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49Yn1g4.html" rel="bookmark" class="title">Playmaker全面实践教程之playMaker编辑器</a>
					<div>
						Playmaker全面实践教程之playMaker编辑器 playMaker编辑器 playMaker编辑器是制作状态机的主要视图,如图1-23所示.只有熟悉此视图,读者才能更加快捷的使用Playma ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
